*+
*+
*+    Source Module => H:\DLOADS\FTP\TEMP\DUPL.PRG
*+
*+    Functions: Function dupl()
*+               Function KEY()
*+
*+       Tables: use ( Mfile )
*+
*+      Indexes: index on KEY() to DUMMY1
*+
*+    Reformatted by Click! 1.11 on Sep-21-1997 at 10:46 pm
*+
*+

/*
I have Summer'87 code for listing duplicate records in a dbf. I'll post it
if you want.

1. It asks for the file name
2. It lists the fields, and then asks for which field(s) combination
should be unique.
3. It prints a list of the record numbers containing duplicate keys.

Actually it's not too long. I'll post it now...

Fred Zuckerman
ZuckermanF@aol.com
San Diego
*/

* DUPL.PRG
* Finds Records With Duplicate Key Fields

*+
*+
*+    Function dupl()
*+
*+
*+
function dupl()

CLEAR

Mfile := "C:\DBASE\              "
@  1,  5 say "ENTER FILENAME " get Mfile        

read

use ( Mfile )

DECLARE Fname[ fcount() ], Ftype[ fcount() ], Flen[ fcount() ], Fdec[ fcount() ], Fnum[ 5 ]

afill( Fnum, 0 )
afields( Fname, Ftype, Flen, Fdec )

ROW := 2
COL := 0
for i := 1 to fcount()
   @ ROW, COL     say str( i, 2 ) + "."         
   @ ROW, COL + 5 say Fname[ i ]                
   ROW ++
   IF ROW >= 20
      ROW := 2
      COL += 15
   endif
next

@ 22,  5 say "ENTER FIELDS TO CHECK"                  
@ 22, 30 get Fnum[ 1 ]               pict '##'        
@ 22, 35 get Fnum[ 2 ]               pict '##'        
@ 22, 40 get Fnum[ 3 ]               pict '##'        
@ 22, 45 get Fnum[ 4 ]               pict '##'        
@ 22, 50 get Fnum[ 5 ]               pict '##'        

read

@ 23,  5 say "INDEXING..."         
index on KEY() to DUMMY1

go top
@ 24,  5 say "PRINTING..."         
set device to print
@  1,  5 say dtoc( date() ) + " Duplicates Found In " + rtrim( Mfile ) + " Fields " + ;         
        iif( Fnum[ 1 ] > 0, Fname[ Fnum[ 1 ] ], "" ) + ;
        iif( Fnum[ 2 ] > 0, "+" + Fname[ Fnum[ 2 ] ], "" ) + ;
        iif( Fnum[ 3 ] > 0, "+" + Fname[ Fnum[ 3 ] ], "" ) + ;
        iif( Fnum[ 4 ] > 0, "+" + Fname[ Fnum[ 4 ] ], "" ) + ;
        iif( Fnum[ 5 ] > 0, "+" + Fname[ Fnum[ 5 ] ], "" )
LINE := 3

do while !eof()
   Mrec1 := recno()
   F1    := KEY()
   ***
   skip
   ***
   Mrec2 := recno()
   F2    := KEY()
   ***
   IF F2 == F1
      @ LINE,  1 say str( Mrec1, 5 ) + " AND " + str( Mrec2, 5 ) + "      = " + F1         
      LINE ++
   endif
enddo

eject

set device to screen

close DATABASES
clear memory
erase DUMMY1.NTX

return

*+
*+
*+    Function KEY()
*+
*+    Called from ( dupl.prg     )   3 - function dupl()
*+
*+
*+
function KEY

K := ''
for i := 1 to 5
   IF Fnum[ i ] = 0
      exit
   endif
   Fval := Fname[ Fnum[ i ] ]
   K    += "+"
   do case
   case Ftype[ Fnum[ i ] ] = 'C'
      K += &Fval
   case Ftype[ Fnum[ i ] ] = 'N'
      K += str( &Fval, Flen[ Fnum[ i ] ], Fdec[ Fnum[ i ] ] )
   case Ftype[ Fnum[ i ] ] = 'D'
      K += dtoc( &Fval )
   case Ftype[ Fnum[ i ] ] = 'L'
      K += iif( &Fval, ".T.", ".F." )
   endcase
next

return substr( K, 2 )

*+ EOF: DUPL.PRG
